<template>
  <div>
    <expanded-card
      v-for="searchEngine in $options.searchEngines"
      :key="searchEngine"
      :class="['project-card']"
    >
      <template #title>
        <div class="project-card__title">
          Ключевые слова поисковик '{{ searchEngine }}'
        </div>
      </template>

      <template #content>
        <prime-data-table
          scrollable
          :value="tableData[searchEngine]"
        >
          <prime-column
            v-for="col of columns"
            :key="col.field"
            :field="col.field"
            :header="col.header"
            :sortable="col.sortable"
            :frozen="col.frozen"
            :class="col.class"
          >
            <template #body="{ data }">
              {{ getData(data, col.field) }}
            </template>
          </prime-column>
        </prime-data-table>
      </template>
    </expanded-card>

    <expanded-card
      v-for="searchEngine in $options.searchEngines"
      :key="searchEngine"
      class="project-card"
    >
      <template #title>
        Ключевые слова поисковик '{{ searchEngine }}'
      </template>
      <template #content>
        <prime-chart
          type="line"
          class="project-card_chart"
          :data="chartData[searchEngine]"
          :options="basicOptions"
        />
      </template>
    </expanded-card>
  </div>
</template>

<script lang="ts">
import PrimeChart from 'primevue/chart/Chart.vue';
import PrimeColumn from 'primevue/column/Column.vue';
import PrimeDataTable from 'primevue/datatable/DataTable.vue';
import { defineComponent, PropType } from 'vue';
import { TopResultReplyByGroup } from '@/api/keywords';
import { KeywordGroupWithCount } from '@/models/keywordGroup';
import { tops, searchEngines } from '@/models/results';
import ExpandedCard from '../projectView/ExpandedCard.vue';

export const randomHexColor = (): string => {
  const MIN = 100;
  const MAX = 200;
  const randomInt = (min: number, max: number): number => Math.floor(min + Math.random() * (max + 1 - min));

  const rgb = Array(3)
    .fill(0)
    .map(() => {
      const value = randomInt(MIN, MAX).toString(16);
      return value.length < 2 ? `0${value}` : value;
    });

  return `#${rgb.join('')}`;
};

interface Data {
  colors: Record<string, string>;
  keywordsCountByGroup: Record<string, number>;
}

export default defineComponent({
  name: 'project-info-tops-by-group',
  searchEngines,
  components: {
    ExpandedCard,
    PrimeColumn,
    PrimeDataTable,
    PrimeChart,
  },
  props: {
    topResults: { type: Object as PropType<TopResultReplyByGroup>, required: true },
    date: { type: Array as unknown as PropType<[Date, Date]>, required: true },
  },
  data(): Data {
    return {
      colors: {},
      keywordsCountByGroup: {},
    };
  },
  computed: {
    columns(): { field: string, header: string, sortable: boolean, frozen: boolean, class?: string }[] {
      const columns: { field: string, header: string, sortable: boolean, frozen: boolean, class?: string }[] = [{ field: 'keyword', header: 'Название группы', sortable: true, frozen: true, class: 'project-keyword' }];
      const iteratedDate = new Date(this.date[0]);
      const endTime = this.date[1].getTime();
      while (iteratedDate.getTime() <= endTime) {
        const month = iteratedDate.getMonth() + 1;
        const prettyDate = `${month < 10 ? '0' : ''}${month}-${iteratedDate.getFullYear()}`;
        tops.forEach(top => {
          columns.push({
            field: `${prettyDate}top${top}`,
            header: `${prettyDate} Топ ${top}`,
            sortable: false,
            frozen: false,
            class: 'project-info-tops__value',
          });
        });
        iteratedDate.setMonth(iteratedDate.getMonth() + 1);
      }

      return columns;
    },
    tableData(): Record<typeof searchEngines[number], any[]> {
      const returnedData: Record<typeof searchEngines[number], any[]> = {
        'google.com': [],
        'yandex.ru': [],
      };
      const keywordMap: Record<number, KeywordGroupWithCount> = {};
      for (const keyword of this.topResults.groups) {
        keywordMap[keyword.id] = keyword;
      }
      for (const searchEngine of searchEngines) {
        const keywordsItemMap: Record<number, any> = {};
        const data: any[] = [];
        const filteredTopResults = this.topResults.topResults.filter(topResult => topResult.searchEngine === searchEngine);
        for (const topResult of filteredTopResults) {
          const item: any = { keyword: keywordMap[topResult.groupId].name };
          const date = new Date(topResult.monthYear.split('-').reverse().join('-'));
          date.setMonth(date.getMonth() + 1);
          date.setDate(date.getDate() - 1);
          const daysCount = date.getDate();
          tops.forEach(top => {
            const topValue = topResult[`top${top}`];
            item[`${topResult.monthYear}top${top}`] = ((topValue / (this.keywordsCountByGroup[topResult.groupId] * daysCount)) * 100).toFixed(2);
          });
          if (topResult.groupId in keywordsItemMap) {
            keywordsItemMap[topResult.groupId] = { ...item, ...keywordsItemMap[topResult.groupId] };
          } else {
            keywordsItemMap[topResult.groupId] = { ...item };
          }
        }
        for (const key in keywordsItemMap) {
          data.push(keywordsItemMap[key]);
        }
        for (const keyword of this.topResults.groups) {
          if (data.find(item => item.keyword === keyword.name) === undefined) {
            data.push({ keyword: keyword.name });
          }
        }
        returnedData[searchEngine] = data;
      }
      return returnedData;
    },
    chartData(): Record<typeof searchEngines[number], any> {
      const returnedData: Record<typeof searchEngines[number], any> = {
        'google.com': {},
        'yandex.ru': {},
      };

      for (const searchEngine of searchEngines) {
        const columnExceptFirst = this.columns.slice(1, this.columns.length);
        const labels: string[] = [];
        for (const column of columnExceptFirst) {
        //   if (column.field.includes('top')) {
        //     continue;
        //   }
          labels.push(column.header);
        }
        const datasets = [];

        for (const item of this.tableData[searchEngine]) {
          const data: unknown[] = [];
          for (const column of columnExceptFirst) {
            // if (column.field.includes('top')) {
            //   continue;
            // }
            data.push(this.getData(item, column.field));
          }
          datasets.push({
            label: item.keyword,
            data,
            fill: false,
            borderColor: this.colors[item.keyword],
            backgroundColor: this.colors[item.keyword],
            tension: .4,
          });
        }
        returnedData[searchEngine] = {
          labels,
          datasets,
        };
      }
      return returnedData;
    },
    basicOptions() {
      return {
        plugins: {
          legend: {
            labels: {
              color: '#495057',
            },
          },
        },
        interaction: {
          mode: 'index',
          intersect: false,
        },
        maintainAspectRatio: false,
        scales: {
          x: {
            ticks: {
              color: '#495057',
            },
            grid: {
              color: '#ebedef',
            },
          },
          y: {
            ticks: {
              precision: 0,
              color: '#495057',
            },
            grid: {
              color: '#ebedef',
            },
          },
        },
      };
    },
  },
  watch: {
    topResults: {
      handler() {
        for (const keyword of this.topResults.groups) {
          if (!(keyword.name in this.colors)) {
            this.colors[keyword.name] = keyword.color;
            this.keywordsCountByGroup[keyword.id] = keyword.keywordCount;
          }
        }
      },
      immediate: true,
    },
  },
  methods: {
    getData(data: Record<string, unknown>, field: string ) {
      if (field in data) {
        return data[field];
      }

      return '-';
    },
    // setGoogleSort(event: any) {
    //   if (event.sortOrder === 1 && this.googleSort.field === event.sortField) {
    //     this.googleSort.field = '';
    //     this.googleSort.order = -1;
    //   } else {
    //     this.googleSort.field = event.sortField;
    //     this.googleSort.order = event.sortOrder;
    //   }
    // },
    // setYandexSort(event: any) {
    //   if (event.sortOrder === 1 && this.yandexSort.field === event.sortField) {
    //     this.yandexSort.field = '';
    //     this.yandexSort.order = -1;
    //   } else {
    //     this.yandexSort.field = event.sortField;
    //     this.yandexSort.order = event.sortOrder;
    //   }
    // },
  },
});
</script>
